package org.iphsoft.simon1.stats;

import org.iphsoft.simon1.AndroidPortAdditions;
import org.iphsoft.simon1.AndroidPortAdditions.GameType;

/**
 * Facade for statistics operations
 */
public class StatisticsManager {
	public static synchronized IStatistics getStatistics()
	{
		if (sInstance == null)
		{
			if (AndroidPortAdditions.GAME_TYPE == GameType.IHNM)
			{
				sInstance = new StubStatistics();
			} else
			{
				// Choosing the use the Google Analytics implementation

				//TODO: update to new GoogleAnalytics lib
				sInstance = new GoogleAnalyticsStatistics();
			}
		}

		return sInstance;
	}

	private static IStatistics sInstance = null;
}
