package org.iphsoft.simon1.ui;

import android.content.Context;
import android.graphics.Typeface;
import android.util.AttributeSet;
import android.util.TypedValue;
import android.widget.EditText;

import com.R;

import org.iphsoft.simon1.AndroidPortAdditions;

public class ExtendedEditText extends EditText {

	public ExtendedEditText(Context context, AttributeSet attrs, int defStyle)
	{
		super(context, attrs, defStyle);

		init(context);
	}

	public ExtendedEditText(Context context, AttributeSet attrs)
	{
		super(context, attrs);

		init(context);
	}

	public ExtendedEditText(Context context)
	{
		super(context);

		init(context);
	}

	protected void init(Context context)
	{
		if (!isInEditMode())
		{
			// Set font
			String tfName = null;
			switch (AndroidPortAdditions.GAME_TYPE)
			{
			case SIMON1:
			case SIMON2:
				tfName = "scarecrow.ttf";
				break;
			case T7G:
				tfName = "abaddon.ttf";
				break;
			case FOTAQ:
				tfName = "adventure.ttf";
				break;
			case IHNM:
				tfName = "digitall.ttf";
				break;
			}

			Typeface tf = Typeface.createFromAsset(context.getAssets(), tfName);
			setTypeface(tf);
		}

		// Set button drawable
		setBackgroundResource(R.drawable.text_input);

		// Set text size
		setTextSize(TypedValue.COMPLEX_UNIT_SP, 18);

		int color = 0;
		switch (AndroidPortAdditions.GAME_TYPE)
		{
		case SIMON1:
		case SIMON2:
			color = R.color.black;
			break;
		case T7G:
		case FOTAQ:
		case IHNM:

			color = R.color.white;
			break;
		}
		
		setTextColor(getResources().getColor(color));

	}
}
