/*
 * CursorDrawable.cpp
 *
 *  Created on: Jun 16, 2014
 *      Author: omergilad
 */

#include <backends/platform/android/graphics/CursorDrawable.h>
#include <backends/platform/android/CursorHelper.h>
#include <backends/platform/android/Constants.h>

CursorDrawable::CursorDrawable() : mExtraWidthFactor(1.0) {
	// TODO Auto-generated constructor stub

}

float CursorDrawable::getWidth() const
{
	if (mUsingSnapshot || Drawable::getWidth() != 0)
	{
		return Drawable::getWidth();
	}

	return CursorHelper::instance()->getCursorWidth() / (float)GAME_SCREEN_WIDTH * mExtraWidthFactor;
}

void CursorDrawable::takeBitmapSnapshot()
{
	Drawable::takeBitmapSnapshot();

	float fixedWidth;
	if (Drawable::getWidth() != 0)
		fixedWidth = Drawable::getWidth();
	else
		fixedWidth = CursorHelper::instance()->getCursorWidth() / (float)GAME_SCREEN_WIDTH;
	setWidth(fixedWidth);
}
